module coords                                       ! Coordinates in R² and R³

! Routines:
! 
! undefCoord2DDbl        Sets argument as undefined

  use basicTypes
  use undefVals
  implicit none

!–––––––––––––––––––––––––––––––––––––––––––––––––[ DECLARATIONS AND DEFINITIONS ]––––––––––––––––––––––––––––––––––––––––––––––––––


  !=====================================================[ TYPE DEFINITIONS ]========================================================

  type tyCoord2DReal
    real :: x,y
  end type

  type tyCoord2DDbl
    real(dp) :: x,y
  end type

  type tyCoord2DInt
    integer :: x,y
  end type

  type tyCoord2DBool
    logical :: x,y
  end type

  type tyPolCoordDbl
    real(dp) :: r,th
  end type

  type tyCoord3DReal
    real :: x,y,z
  end type

  type tyCoord3DDbl
    real(dp) :: x,y,z
  end type

  type tyCoord3DInt
    integer :: x,y,z
  end type


!––––––––––––––––––––––––––––––––––––––––––––––––––––––––––[ INTERFACES ]–––––––––––––––––––––––––––––––––––––––––––––––––––––––––––

  interface undef
    module procedure undefCoord2DDbl
  end interface


!–––––––––––––––––––––––––––––––––––––––––––––––––––––––[ SUBPROGRAM PART ]–––––––––––––––––––––––––––––––––––––––––––––––––––––––––

  contains


!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!
!
    elemental subroutine undefCoord2DDbl(coord)
!
!   sets argument as undefined
!
!   Arguments:
!     coord                          var. to be set as undefined
!
!
!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    implicit none
    type(tyCoord2DDbl) :: &
     coord
    intent(inout) :: &
     coord

    call undef(coord%x)
    call undef(coord%y)

  end subroutine undefCoord2DDbl




end module
